#include <catch2/catch.hpp>

#include <utils/EscapedString.hpp>

// clazy:excludeall=non-pod-global-static

TEST_CASE("EscapedString", "[utils]")
{
  SECTION("escape string")
  {
    const std::string s = "foo\'\\\"\?\a\b\f\n\r\t\vbar";

    REQUIRE(escapeString(s) == R"(foo\'\\\"\?\a\b\f\n\r\t\vbar)");
  }

  SECTION("unescape string")
  {
    const std::string s = R"(foo\'\\\"\?\a\b\f\n\r\t\vbar)";

    REQUIRE(unescapeString(s) == std::string{"foo\'\\\"\?\a\b\f\n\r\t\vbar"});
  }
}
